// WindowMessagesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WindowMessages.h"
#include "WindowMessagesDlg.h"
#include "MyMessages.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWindowMessagesDlg dialog

CWindowMessagesDlg::CWindowMessagesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWindowMessagesDlg::IDD, pParent),
	  m_LastViewer(0),
	  m_notreat(FALSE)
{
	//{{AFX_DATA_INIT(CWindowMessagesDlg)
	//}}AFX_DATA_INIT
}

void CWindowMessagesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWindowMessagesDlg)
	DDX_Control(pDX, IDC_EDIT_MSG, m_Edit1);
	DDX_Control(pDX, IDC_EDIT_MSG2, m_Edit2);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CWindowMessagesDlg, CDialog)
	//{{AFX_MSG_MAP(CWindowMessagesDlg)
	ON_EN_UPDATE(IDC_EDIT_MSG, OnUpdateEditMsg)
	ON_EN_UPDATE(IDC_EDIT_MSG2, OnUpdateEditMsg2)
	ON_WM_CLOSE()
	ON_WM_CTLCOLOR()
	ON_EN_SETFOCUS(IDC_EDIT_MSG, OnSetfocusEditMsg)
	ON_EN_SETFOCUS(IDC_EDIT_MSG2, OnSetfocusEditMsg2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWindowMessagesDlg message handlers

BOOL CWindowMessagesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_Gray.CreateSysColorBrush(COLOR_3DFACE);

	CheckClipboardData();

//	m_LastViewer = this->SetClipboardViewer();
	m_Edit2.SubclassDlgItem(IDC_EDIT_MSG2, this);
	m_Edit1.SetLimitText(10);
	m_Edit2.SetLimitText(8);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CWindowMessagesDlg::CheckClipboardData() 
{
	CString clipdata(LPCTSTR(NULL));

	if (::OpenClipboard(m_hWnd))
	{
		if (::IsClipboardFormatAvailable(CF_TEXT))
		{
			HANDLE hMem = ::GetClipboardData(CF_TEXT);
			if (hMem)
			{
				clipdata = LPCTSTR(GlobalLock(hMem));
				GlobalUnlock(hMem);
			}
		}
		::CloseClipboard();
	}

	if (!clipdata.IsEmpty())
	{
		LPTSTR endchar;
		ULONG x = _tcstoul(clipdata, &endchar, 10);

		if (endchar != clipdata)
			SetDlgItemInt(IDC_EDIT_MSG, x, FALSE);
		else
		{
			x = _tcstoul(clipdata, &endchar, 16);
			if (endchar != clipdata)
				SetDlgItemInt(IDC_EDIT_MSG, x, FALSE);
			else
				SetDlgItemInt(IDC_EDIT_MSG, 0, FALSE);
		}
	}
}

void CWindowMessagesDlg::OnOK() 
{
	CDialog::OnOK();
	EndDialog(0);
}

void CWindowMessagesDlg::OnUpdateEditMsg() 
{
	if (m_notreat)
		return;
	CString output, temp;
	BOOL bTrans;
	
	UINT x = GetDlgItemInt(IDC_EDIT_MSG, &bTrans, FALSE);
	if (!bTrans) // no conversion
	{
		if (output.IsEmpty())
			output = _T("<none>");
		SetDlgItemText(IDC_EDIT_MEANING, output);
		m_notreat = TRUE;
		SetDlgItemText(IDC_EDIT_MSG, NULL);
		SetDlgItemText(IDC_EDIT_MSG2, NULL);
		m_notreat = FALSE;
		return;
	}


	temp.Format(_T("%X"), x);
	m_notreat = TRUE;
	SetDlgItemText(IDC_EDIT_MSG2, temp);
	m_notreat = FALSE;

	PrepareOutput(x);
}

void CWindowMessagesDlg::OnUpdateEditMsg2() 
{
	if (m_notreat)
		return;
	CString output, temp;
	
	GetDlgItemText(IDC_EDIT_MSG2, temp);
	LPTSTR endchar;
	UINT x = _tcstoul(temp, &endchar, 16);
	if (endchar == temp) // no conversion
	{
		if (output.IsEmpty())
			output = _T("<none>");
		SetDlgItemText(IDC_EDIT_MEANING, output);
		m_notreat = TRUE;
		SetDlgItemText(IDC_EDIT_MSG, NULL);
		SetDlgItemText(IDC_EDIT_MSG2, NULL);
		m_notreat = FALSE;
		return;
	}

	temp.Format(_T("%d"), x);
	m_notreat = TRUE;
	SetDlgItemText(IDC_EDIT_MSG, temp);
	m_notreat = FALSE;

	PrepareOutput(x);
}

void CWindowMessagesDlg::PrepareOutput(UINT value)
{
	CString output, prep;
	const MAPMSG* pMsgMap = MessageMap;

	if((value >= WM_USER) && (value <= 0x7FFF))
		prep.Format(TEXT("[b]%sWM_USER + %4.4X%s[/b]\r\n"), szRtfColorRed, value - WM_USER, szRtfColorBlack);

	if((value >= WM_APP) && (value <= 0xBFFF))
		prep.Format(TEXT("[b]%sWM_APP + %4.4X%s[/b]\r\n"), szRtfColorRed, value - WM_APP, szRtfColorBlack);
	 
	CString formatted(prep);
	for(; pMsgMap->szMsg != NULL; pMsgMap++)
	{
		if(pMsgMap->uMsg == value)
		{
			formatted += pMsgMap->szMsg;

			break;
		}
	}
	// Now replace some parts by RTF formatting
	formatted.Replace(TEXT("[b]"), szRtfBoldStart);
	formatted.Replace(TEXT("[/b]"), szRtfBoldEnd);
	formatted.Replace(TEXT("\r\n"), szRtfNewline);
	formatted.Replace(TEXT("[hr]"), szRtfHorzRule);
	formatted.Replace(TEXT("<"), szRtfColorGrayFN);
	formatted.Replace(TEXT(">"), szRtfColorBlackFN);
	if(!formatted.IsEmpty())
		output.Format(szRtfWrap, formatted);
	if (output.IsEmpty())
		output = _T("<none>");
	SetDlgItemText(IDC_EDIT_MEANING, output);
	// Scroll up ...
	SendDlgItemMessage(IDC_EDIT_MEANING, EM_SCROLL, SB_PAGEUP, 0);
	SendDlgItemMessage(IDC_EDIT_MEANING, EM_SCROLL, SB_PAGEUP, 0);
}

void CWindowMessagesDlg::OnClose() 
{
//	ChangeClipboardChain(m_LastViewer);

	CDialog::OnClose();
}

HBRUSH CWindowMessagesDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) 
{
	HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
	
	switch(nCtlColor)
	{
	case CTLCOLOR_EDIT: // Edit control
		switch(pWnd->GetDlgCtrlID())
		{
		case IDC_EDIT_MSG:
			if(m_Focus != IDC_EDIT_MSG)
			{
				pDC->SetBkColor(GetSysColor(COLOR_3DFACE));
				hbr = HBRUSH(m_Gray);
			}
			break;
		case IDC_EDIT_MSG2:
			if(m_Focus != IDC_EDIT_MSG2)
			{
				pDC->SetBkColor(GetSysColor(COLOR_3DFACE));
				hbr = HBRUSH(m_Gray);
			}
			break;
		}
	}
	return hbr;
}

void CWindowMessagesDlg::OnSetfocusEditMsg() 
{
	UINT oldfocus = m_Focus;
	m_Focus = IDC_EDIT_MSG;
	if (m_Focus != oldfocus)
	{
		m_Edit1.RedrawWindow();
		m_Edit2.RedrawWindow();
	}
}

void CWindowMessagesDlg::OnSetfocusEditMsg2() 
{
	UINT oldfocus = m_Focus;
	m_Focus = IDC_EDIT_MSG2;
	if (m_Focus != oldfocus)
	{
		m_Edit1.RedrawWindow();
		m_Edit2.RedrawWindow();
	}
}
